#ifndef lint
static char const 
yyrcsid[] = "$FreeBSD: src/usr.bin/yacc/skeleton.c,v 1.28 2000/01/17 02:04:06 bde Exp $";
#endif
#include <stdlib.h>
#define YYBYACC 1
#define YYMAJOR 1
#define YYMINOR 9
#define YYLEX yylex()
#define YYEMPTY -1
#define yyclearin (yychar=(YYEMPTY))
#define yyerrok (yyerrflag=0)
#define YYRECOVERING() (yyerrflag!=0)
static int yygrowstack();
#define YYPREFIX "yy"
#line 80 "rpld_conf.y"

static char rcsid[]="$Id: rpld_conf.y,v 1.8 2001/11/01 15:23:59 root Exp $";

#include "project.h"

/* state machine stuff*/

typedef enum {START, BLOCK_START, BLOCK_END, ASSERTION, ASSIGNMENT} THING ;
typedef enum {INIT, GLOBALBLOCK, HOSTBLOCK, FILEBLOCK} STATE ;

/*void process_thing(THING thing, char *name, int type, YYSTYPE *pvalue);*/

#line 96 "rpld_conf.y"
typedef union {
		long number;
		char *name;
		char *text;
		char mac_address[6];
		struct partial_mac {
			char mac_address[6];
			int mac_len;
		} pm;
	} YYSTYPE;
#line 41 "rpld_conf.tab.c"
#define YYERRCODE 256
#define BLOCK_START 257
#define BLOCK_END 258
#define NAME 259
#define TEXT 260
#define NUMBER 261
#define MACADDR 262
#define MACADDR_PARTIAL 263
const short yylhs[] = {                                        -1,
    0,    0,    1,    1,    2,    2,    3,    3,    3,    4,
    4,    4,    4,    4,    4,
};
const short yylen[] = {                                         2,
    2,    3,    3,    2,    2,    1,    1,    2,    3,    1,
    3,    3,    3,    3,    1,
};
const short yydefred[] = {                                      0,
    6,    0,    0,    0,    0,    5,    0,    1,    4,    0,
    7,   15,    0,    0,    2,    0,    3,    0,    8,   11,
   12,   13,   14,    9,
};
const short yydgoto[] = {                                       3,
   12,    5,   13,   14,
};
const short yysindex[] = {                                   -244,
    0, -250, -244,  -51,  -59,    0,  -45,    0,    0,  -60,
    0,    0, -247,  -43,    0, -258,    0,  -42,    0,    0,
    0,    0,    0,    0,
};
const short yyrindex[] = {                                      0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,  -41,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,
};
const short yygindex[] = {                                      0,
    6,    0,    0,    7,
};
#define YYTABLESIZE 200
const short yytable[] = {                                      11,
   16,   20,   21,   22,   23,    4,    6,    8,    7,    1,
   17,   10,    1,   15,    2,   19,   24,   10,    0,   18,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    6,    1,    9,   10,
};
const short yycheck[] = {                                      59,
   61,  260,  261,  262,  263,    0,  257,   59,    3,  257,
  258,  259,  257,   59,  259,   59,   59,   59,   -1,   13,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,  257,  257,  258,  259,
};
#define YYFINAL 3
#ifndef YYDEBUG
#define YYDEBUG 0
#endif
#define YYMAXTOKEN 263
#if YYDEBUG
const char * const yyname[] = {
"end-of-file",0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,"';'",0,"'='",0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,"BLOCK_START","BLOCK_END",
"NAME","TEXT","NUMBER","MACADDR","MACADDR_PARTIAL",
};
const char * const yyrule[] = {
"$accept : block_list",
"block_list : block ';'",
"block_list : block_list block ';'",
"block : block_start statement_list BLOCK_END",
"block : block_start BLOCK_END",
"block_start : NAME BLOCK_START",
"block_start : BLOCK_START",
"statement_list : ';'",
"statement_list : statement ';'",
"statement_list : statement_list statement ';'",
"statement : NAME",
"statement : NAME '=' TEXT",
"statement : NAME '=' NUMBER",
"statement : NAME '=' MACADDR",
"statement : NAME '=' MACADDR_PARTIAL",
"statement : block",
};
#endif
#if YYDEBUG
#include <stdio.h>
#endif
#ifdef YYSTACKSIZE
#undef YYMAXDEPTH
#define YYMAXDEPTH YYSTACKSIZE
#else
#ifdef YYMAXDEPTH
#define YYSTACKSIZE YYMAXDEPTH
#else
#define YYSTACKSIZE 10000
#define YYMAXDEPTH 10000
#endif
#endif
#define YYINITSTACKSIZE 200
int yydebug;
int yynerrs;
int yyerrflag;
int yychar;
short *yyssp;
YYSTYPE *yyvsp;
YYSTYPE yyval;
YYSTYPE yylval;
short *yyss;
short *yysslim;
YYSTYPE *yyvs;
int yystacksize;
#line 134 "rpld_conf.y"

//
// ERROR REPORTING
//

// the lineno variable from our parser
extern int lineno;

// the yytext variable from lex for error reporting
extern char* yytext;

void yyerror(char *s)
{
	fprintf(stderr, "rpld: config line %d: %s near `%s'\n", lineno, s, yytext);
}

//
// CONFIGURATION PROCESSOR
//

// This is the bit that actually does the work

#define strsame(a, b)	(!strcmp((a), (b)))
/*
struct global_parameters
{

} g_params;
*/

struct clientinfo
{
	int have_mac;
	int have_run_addr;
	int have_files;
	// optional
	int have_framesize;
	int have_blocksize;
	int have_pacing;
	int have_nospew;
};

struct clfileinfo
{
	int have_path;
	int have_load_addr;
	// optional
	int have_offset;
	int have_length;
};

extern struct client *clients;

// hideous, we need to cope with a semicolon after this
//#define THROW_ERROR(a)	do { yyerror((a)); exit(1); } while(0)
#define THROW_ERROR(a)	do { fprintf(stderr, "rpld: config line %d: %s near `%s'\n", lineno, (a), name); exit(1); } while(0)

void process_thing(THING thing, char *name, int type, YYSTYPE *pvalue)
{
	static STATE state;
	static struct client *pc;
	static struct clientinfo ci;
	static struct clfile *pcf;
	static struct clfileinfo cfi;

	switch(thing)
	{
	// boot the state machine
	case START:
		state = INIT;
		break;

	//
	// Blocks, which contain related options
	//
	
	// start of a block
	case BLOCK_START:
		// in initial state, move to GLOBALBLOCK or HOSTBLOCK
		if (state == INIT) {
			if (strsame(name, "GLOBAL")) {
				state = GLOBALBLOCK;
				break;
			} else if (strsame(name, "HOST") || strsame(name, "CLIENT")) {
				// construct a new client entity
				pc = (struct client*)malloc(sizeof(struct client));
				bzero(pc, sizeof(struct client));
				// reset info about what options have been set for this client
				bzero(&ci, sizeof(ci));

				pc->blocklen=MY_BLOCK_LEN;
				pc->framelen=MY_FRAME_LEN;
				pc->pacing=MY_PACING;
				
				state = HOSTBLOCK;
				break;
			} else THROW_ERROR("Unknown top-level parameter block");
		}
		// in a HOST block, this must be a FILE
		else if (state == HOSTBLOCK) {
			if (strsame(name, "FILE")) {
				// construct a new file entity
				pcf = (struct clfile*)malloc(sizeof(struct clfile));
				bzero(pcf, sizeof(struct clfile));
				pcf->length=-1;
				// reset info about options set for this file
				bzero(&cfi, sizeof(cfi));
				
				state = FILEBLOCK;
				break;
			} else THROW_ERROR("Only a FILE parameter block can be included in a HOST block");
		}
		// fuck knows
		else
		{
			yyerror("Unknown parameter block");
			exit(1);
		}
		break;

	// end of a block, we should have a bunch of info now
	case BLOCK_END:
		// end GLOBAL block
		if (state == GLOBALBLOCK) {
			// no more global params, at least for the moment
		}
		// end HOST block
		else if (state == HOSTBLOCK) {
			// should have a complete host specification
			if (!ci.have_mac) THROW_ERROR("Must specify an ethernet (MAC) address for host");
			else if (!ci.have_run_addr) THROW_ERROR("Must specify an initial execute address for host");
			else if (!ci.have_files) THROW_ERROR("Must specify at least one file to load for host");

			// OK, should have an entire host spec, so copy it in
			pc->next = clients;
			clients = pc;

			// finished this host spec
			state = INIT;
			break;
		}
		// end FILE block
		else if (state == FILEBLOCK) {
			// should have a complete file specification
			if (!cfi.have_path) THROW_ERROR("Must specify a path for file");
			else if (!cfi.have_load_addr) THROW_ERROR("Must specify a load address for file");

			// have an entire file spec, copy it into the host spec
			pcf->next = pc->files;
			pc->files = pcf;

			ci.have_files = 1;

			// done
			state = HOSTBLOCK;
			break;
		}

	//
	// The various things that go inside blocks
	//
	
	case ASSERTION:
		if (state == GLOBALBLOCK) {
			// no global assertions ATM
			THROW_ERROR("Unknown directive");
		} else if (state == HOSTBLOCK) {
			// no host assertions ATM
			if (strsame(name,"nospew")) {
				if (ci.have_pacing) THROW_ERROR("Directive nospew incompatible with pacing ");
				if (ci.have_nospew) THROW_ERROR("Repeated directive");
				ci.have_nospew=1;
				pc->nospew++;
			} else THROW_ERROR("Unknown directive");
		} else if (state == FILEBLOCK) {
			if (strsame(name,"linux")) {
				if (!cfi.have_path) THROW_ERROR("A path to a valid kernel must precede linux");

				do_linux_kernel(pc,pcf);
				cfi.have_load_addr=1;
				cfi.have_offset=1;
				cfi.have_length=1;
				ci.have_run_addr=1;
			}else{
			THROW_ERROR("Unknown directive");
			}
		} else THROW_ERROR("Unknown directive");
		break;

	case ASSIGNMENT:
		if (state == GLOBALBLOCK) {
			// no global assignments ATM
			THROW_ERROR("Unknown directive");
		} else if (state == HOSTBLOCK) {
			// ethernet address
			if (strsame(name, "ethernet") || strsame(name, "mac")) {
				if (type != MACADDR && type != MACADDR_PARTIAL)
					THROW_ERROR("Directive must be followed by a (partial or complete) ethernet address");
				else if (ci.have_mac) THROW_ERROR("Repeated directive");

				if (type == MACADDR) {
					// set MAC address; this is non-partial, so len = ETH_ALEN
					bcopy(pvalue->mac_address, pc->mac, ETH_ALEN);
					pc->partial_mac_len = ETH_ALEN;
				} else {
					bcopy(pvalue->pm.mac_address, pc->mac, pvalue->pm.mac_len);
					pc->partial_mac_len = pvalue->pm.mac_len;
				}

				ci.have_mac = 1;
			}
			// execute address
			else if (strsame(name, "execute") || strsame(name, "run")) {
				if (type != NUMBER) THROW_ERROR("Directive must be followed by a memory address");
				else if (ci.have_run_addr==2) THROW_ERROR("Repeated directive");

				// set address
				pc->run_addr = pvalue->number;
				ci.have_run_addr = 2;
			}
			else if (strsame(name, "blocksize")) {
				if (type != NUMBER) THROW_ERROR("Directive must be followed by an integer ");
				else if (ci.have_blocksize) THROW_ERROR("Repeated directive");

				// set address
				pc->blocklen = pvalue->number;
				ci.have_blocksize = 1;
			}
			else if (strsame(name, "framesize")) {
				if (type != NUMBER) THROW_ERROR("Directive must be followed by an integer ");
				else if (ci.have_framesize) THROW_ERROR("Repeated directive");

				// set size
				pc->framelen = pvalue->number;
				ci.have_framesize = 1;
			}
			else if (strsame(name,"pacing")) {
				if (type != NUMBER) THROW_ERROR("Directive must be followed by an integer ");
				if (ci.have_nospew) THROW_ERROR("Directive pacing incompatible with nospew ");
				if (ci.have_pacing) THROW_ERROR("Repeated directive");
				pc->pacing = pvalue->number;
				ci.have_pacing =1;
			}
			else THROW_ERROR("Unknown directive");
		} else if (state == FILEBLOCK) {
			// path
			if (strsame(name, "path")) {
				if (type != TEXT) THROW_ERROR("Directive must be followed by a filename");
				else if (cfi.have_path) THROW_ERROR("Repeated directive");

				// set filename
				pcf->path = pvalue->text;
				cfi.have_path = 1;
			}
			// load address
			else if (strsame(name, "load")) {
				if (type != NUMBER) THROW_ERROR("Directive must be followed by a memory address");
				else if (cfi.have_load_addr) THROW_ERROR("Repeated directive");

				// set load address
				pcf->load_addr = pvalue->number;
				cfi.have_load_addr = 1;
			}
			// offset
			else if (strsame(name, "offset")) {
				if (type != NUMBER) THROW_ERROR("Directive must be followed by a memory address");
				else if (cfi.have_offset) THROW_ERROR("Repeated directive");

				// set offset
				pcf->offset = pvalue->number;
				cfi.have_offset = 1;
			}
			// length
			else if (strsame(name, "length")) {
				if (type != NUMBER) THROW_ERROR("Directive must be followed by a memory address");
				else if (cfi.have_length) THROW_ERROR("Repeated directive");

				// set length
				pcf->length = pvalue->number;
				cfi.have_length = 1;
			}
			else THROW_ERROR("Unknown directive");
		}
		break;

		default: THROW_ERROR("Mistake");
	}
	

}
#line 477 "rpld_conf.tab.c"
/* allocate initial stack or double stack size, up to YYMAXDEPTH */
static int yygrowstack()
{
    int newsize, i;
    short *newss;
    YYSTYPE *newvs;

    if ((newsize = yystacksize) == 0)
        newsize = YYINITSTACKSIZE;
    else if (newsize >= YYMAXDEPTH)
        return -1;
    else if ((newsize *= 2) > YYMAXDEPTH)
        newsize = YYMAXDEPTH;
    i = yyssp - yyss;
    newss = yyss ? (short *)realloc(yyss, newsize * sizeof *newss) :
      (short *)malloc(newsize * sizeof *newss);
    if (newss == NULL)
        return -1;
    yyss = newss;
    yyssp = newss + i;
    newvs = yyvs ? (YYSTYPE *)realloc(yyvs, newsize * sizeof *newvs) :
      (YYSTYPE *)malloc(newsize * sizeof *newvs);
    if (newvs == NULL)
        return -1;
    yyvs = newvs;
    yyvsp = newvs + i;
    yystacksize = newsize;
    yysslim = yyss + newsize - 1;
    return 0;
}

#define YYABORT goto yyabort
#define YYREJECT goto yyabort
#define YYACCEPT goto yyaccept
#define YYERROR goto yyerrlab

#ifndef YYPARSE_PARAM
#if defined(__cplusplus) || __STDC__
#define YYPARSE_PARAM_ARG void
#define YYPARSE_PARAM_DECL
#else	/* ! ANSI-C/C++ */
#define YYPARSE_PARAM_ARG
#define YYPARSE_PARAM_DECL
#endif	/* ANSI-C/C++ */
#else	/* YYPARSE_PARAM */
#ifndef YYPARSE_PARAM_TYPE
#define YYPARSE_PARAM_TYPE void *
#endif
#if defined(__cplusplus) || __STDC__
#define YYPARSE_PARAM_ARG YYPARSE_PARAM_TYPE YYPARSE_PARAM
#define YYPARSE_PARAM_DECL
#else	/* ! ANSI-C/C++ */
#define YYPARSE_PARAM_ARG YYPARSE_PARAM
#define YYPARSE_PARAM_DECL YYPARSE_PARAM_TYPE YYPARSE_PARAM;
#endif	/* ANSI-C/C++ */
#endif	/* ! YYPARSE_PARAM */

int
yyparse (YYPARSE_PARAM_ARG)
    YYPARSE_PARAM_DECL
{
    register int yym, yyn, yystate;
#if YYDEBUG
    register const char *yys;

    if ((yys = getenv("YYDEBUG")))
    {
        yyn = *yys;
        if (yyn >= '0' && yyn <= '9')
            yydebug = yyn - '0';
    }
#endif

    yynerrs = 0;
    yyerrflag = 0;
    yychar = (-1);

    if (yyss == NULL && yygrowstack()) goto yyoverflow;
    yyssp = yyss;
    yyvsp = yyvs;
    *yyssp = yystate = 0;

yyloop:
    if ((yyn = yydefred[yystate])) goto yyreduce;
    if (yychar < 0)
    {
        if ((yychar = yylex()) < 0) yychar = 0;
#if YYDEBUG
        if (yydebug)
        {
            yys = 0;
            if (yychar <= YYMAXTOKEN) yys = yyname[yychar];
            if (!yys) yys = "illegal-symbol";
            printf("%sdebug: state %d, reading %d (%s)\n",
                    YYPREFIX, yystate, yychar, yys);
        }
#endif
    }
    if ((yyn = yysindex[yystate]) && (yyn += yychar) >= 0 &&
            yyn <= YYTABLESIZE && yycheck[yyn] == yychar)
    {
#if YYDEBUG
        if (yydebug)
            printf("%sdebug: state %d, shifting to state %d\n",
                    YYPREFIX, yystate, yytable[yyn]);
#endif
        if (yyssp >= yysslim && yygrowstack())
        {
            goto yyoverflow;
        }
        *++yyssp = yystate = yytable[yyn];
        *++yyvsp = yylval;
        yychar = (-1);
        if (yyerrflag > 0)  --yyerrflag;
        goto yyloop;
    }
    if ((yyn = yyrindex[yystate]) && (yyn += yychar) >= 0 &&
            yyn <= YYTABLESIZE && yycheck[yyn] == yychar)
    {
        yyn = yytable[yyn];
        goto yyreduce;
    }
    if (yyerrflag) goto yyinrecovery;
#if defined(lint) || defined(__GNUC__)
    goto yynewerror;
#endif
yynewerror:
    yyerror("syntax error");
#if defined(lint) || defined(__GNUC__)
    goto yyerrlab;
#endif
yyerrlab:
    ++yynerrs;
yyinrecovery:
    if (yyerrflag < 3)
    {
        yyerrflag = 3;
        for (;;)
        {
            if ((yyn = yysindex[*yyssp]) && (yyn += YYERRCODE) >= 0 &&
                    yyn <= YYTABLESIZE && yycheck[yyn] == YYERRCODE)
            {
#if YYDEBUG
                if (yydebug)
                    printf("%sdebug: state %d, error recovery shifting\
 to state %d\n", YYPREFIX, *yyssp, yytable[yyn]);
#endif
                if (yyssp >= yysslim && yygrowstack())
                {
                    goto yyoverflow;
                }
                *++yyssp = yystate = yytable[yyn];
                *++yyvsp = yylval;
                goto yyloop;
            }
            else
            {
#if YYDEBUG
                if (yydebug)
                    printf("%sdebug: error recovery discarding state %d\n",
                            YYPREFIX, *yyssp);
#endif
                if (yyssp <= yyss) goto yyabort;
                --yyssp;
                --yyvsp;
            }
        }
    }
    else
    {
        if (yychar == 0) goto yyabort;
#if YYDEBUG
        if (yydebug)
        {
            yys = 0;
            if (yychar <= YYMAXTOKEN) yys = yyname[yychar];
            if (!yys) yys = "illegal-symbol";
            printf("%sdebug: state %d, error recovery discards token %d (%s)\n",
                    YYPREFIX, yystate, yychar, yys);
        }
#endif
        yychar = (-1);
        goto yyloop;
    }
yyreduce:
#if YYDEBUG
    if (yydebug)
        printf("%sdebug: state %d, reducing by rule %d (%s)\n",
                YYPREFIX, yystate, yyn, yyrule[yyn]);
#endif
    yym = yylen[yyn];
    yyval = yyvsp[1-yym];
    switch (yyn)
    {
case 3:
#line 115 "rpld_conf.y"
{ process_thing(BLOCK_END, "", 0, NULL); }
break;
case 4:
#line 116 "rpld_conf.y"
{ process_thing(BLOCK_END, "", 0, NULL); }
break;
case 5:
#line 118 "rpld_conf.y"
{ process_thing(BLOCK_START, yyvsp[-1].name, 0, NULL); }
break;
case 6:
#line 119 "rpld_conf.y"
{ process_thing(BLOCK_START, "", 0, NULL); }
break;
case 10:
#line 126 "rpld_conf.y"
{ process_thing(ASSERTION, yyvsp[0].name, 0, NULL); }
break;
case 11:
#line 127 "rpld_conf.y"
{ process_thing(ASSIGNMENT, yyvsp[-2].name, TEXT, &yyvsp[0]); }
break;
case 12:
#line 128 "rpld_conf.y"
{ process_thing(ASSIGNMENT, yyvsp[-2].name, NUMBER, &yyvsp[0]); }
break;
case 13:
#line 129 "rpld_conf.y"
{ process_thing(ASSIGNMENT, yyvsp[-2].name, MACADDR, &yyvsp[0]); }
break;
case 14:
#line 130 "rpld_conf.y"
{ process_thing(ASSIGNMENT, yyvsp[-2].name, MACADDR_PARTIAL, &yyvsp[0]); }
break;
#line 708 "rpld_conf.tab.c"
    }
    yyssp -= yym;
    yystate = *yyssp;
    yyvsp -= yym;
    yym = yylhs[yyn];
    if (yystate == 0 && yym == 0)
    {
#if YYDEBUG
        if (yydebug)
            printf("%sdebug: after reduction, shifting from state 0 to\
 state %d\n", YYPREFIX, YYFINAL);
#endif
        yystate = YYFINAL;
        *++yyssp = YYFINAL;
        *++yyvsp = yyval;
        if (yychar < 0)
        {
            if ((yychar = yylex()) < 0) yychar = 0;
#if YYDEBUG
            if (yydebug)
            {
                yys = 0;
                if (yychar <= YYMAXTOKEN) yys = yyname[yychar];
                if (!yys) yys = "illegal-symbol";
                printf("%sdebug: state %d, reading %d (%s)\n",
                        YYPREFIX, YYFINAL, yychar, yys);
            }
#endif
        }
        if (yychar == 0) goto yyaccept;
        goto yyloop;
    }
    if ((yyn = yygindex[yym]) && (yyn += yystate) >= 0 &&
            yyn <= YYTABLESIZE && yycheck[yyn] == yystate)
        yystate = yytable[yyn];
    else
        yystate = yydgoto[yym];
#if YYDEBUG
    if (yydebug)
        printf("%sdebug: after reduction, shifting from state %d \
to state %d\n", YYPREFIX, *yyssp, yystate);
#endif
    if (yyssp >= yysslim && yygrowstack())
    {
        goto yyoverflow;
    }
    *++yyssp = yystate;
    *++yyvsp = yyval;
    goto yyloop;
yyoverflow:
    yyerror("yacc stack overflow");
yyabort:
    return (1);
yyaccept:
    return (0);
}
